spandsp 0.0.6

echo.h
Go to the documentation of this file.
1/*
2 * SpanDSP - a series of DSP components for telephony
3 *
4 * echo.h - An echo cancellor, suitable for electrical and acoustic
5 * cancellation. This code does not currently comply with
6 * any relevant standards (e.g. G.164/5/7/8).
7 *
8 * Written by Steve Underwood <steveu@coppice.org>
9 *
10 * Copyright (C) 2001 Steve Underwood
11 *
12 * All rights reserved.
13 *
14 * This program is free software; you can redistribute it and/or modify
15 * it under the terms of the GNU Lesser General Public License version 2.1,
16 * as published by the Free Software Foundation.
17 *
18 * This program is distributed in the hope that it will be useful,
19 * but WITHOUT ANY WARRANTY; without even the implied warranty of
20 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
21 * GNU Lesser General Public License for more details.
22 *
23 * You should have received a copy of the GNU Lesser General Public
24 * License along with this program; if not, write to the Free Software
25 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
26 */
27
28/*! \file */
29
30#if !defined(_SPANDSP_ECHO_H_)
31#define _SPANDSP_ECHO_H_
32
33/*! \page echo_can_page Line echo cancellation for voice
34
35\section echo_can_page_sec_1 What does it do?
36 This module aims to provide G.168-2002 compliant echo cancellation, to remove
37 electrical echoes (e.g. from 2-4 wire hybrids) from voice calls.
38
39\section echo_can_page_sec_2 How does it work?
40 The heart of the echo cancellor is FIR filter. This is adapted to match the echo
41 impulse response of the telephone line. It must be long enough to adequately cover
42 the duration of that impulse response. The signal transmitted to the telephone line
43 is passed through the FIR filter. Once the FIR is properly adapted, the resulting
44 output is an estimate of the echo signal received from the line. This is subtracted
45 from the received signal. The result is an estimate of the signal which originated
46 at the far end of the line, free from echos of our own transmitted signal.
47
48 The least mean squares (LMS) algorithm is attributed to Widrow and Hoff, and was
49 introduced in 1960. It is the commonest form of filter adaption used in things
50 like modem line equalisers and line echo cancellers. There it works very well.
51 However, it only works well for signals of constant amplitude. It works very poorly
52 for things like speech echo cancellation, where the signal level varies widely.
53 This is quite easy to fix. If the signal level is normalised - similar to applying
54 AGC - LMS can work as well for a signal of varying amplitude as it does for a modem
55 signal. This normalised least mean squares (NLMS) algorithm is the commonest one used
56 for speech echo cancellation. Many other algorithms exist - e.g. RLS (essentially
57 the same as Kalman filtering), FAP, etc. Some perform significantly better than NLMS.
58 However, factors such as computational complexity and patents favour the use of NLMS.
59
60 A simple refinement to NLMS can improve its performance with speech. NLMS tends
61 to adapt best to the strongest parts of a signal. If the signal is white noise,
62 the NLMS algorithm works very well. However, speech has more low frequency than
63 high frequency content. Pre-whitening (i.e. filtering the signal to flatten
64 its spectrum) the echo signal improves the adapt rate for speech, and ensures the
65 final residual signal is not heavily biased towards high frequencies. A very low
66 complexity filter is adequate for this, so pre-whitening adds little to the
67 compute requirements of the echo canceller.
68
69 An FIR filter adapted using pre-whitened NLMS performs well, provided certain
70 conditions are met:
71
72 - The transmitted signal has poor self-correlation.
73 - There is no signal being generated within the environment being cancelled.
74
75 The difficulty is that neither of these can be guaranteed.
76
77 If the adaption is performed while transmitting noise (or something fairly noise
78 like, such as voice) the adaption works very well. If the adaption is performed
79 while transmitting something highly correlative (typically narrow band energy
80 such as signalling tones or DTMF), the adaption can go seriously wrong. The reason
81 is there is only one solution for the adaption on a near random signal - the impulse
82 response of the line. For a repetitive signal, there are any number of solutions
83 which converge the adaption, and nothing guides the adaption to choose the generalised
84 one. Allowing an untrained canceller to converge on this kind of narrowband
85 energy probably a good thing, since at least it cancels the tones. Allowing a well
86 converged canceller to continue converging on such energy is just a way to ruin
87 its generalised adaption. A narrowband detector is needed, so adapation can be
88 suspended at appropriate times.
89
90 The adaption process is based on trying to eliminate the received signal. When
91 there is any signal from within the environment being cancelled it may upset the
92 adaption process. Similarly, if the signal we are transmitting is small, noise
93 may dominate and disturb the adaption process. If we can ensure that the
94 adaption is only performed when we are transmitting a significant signal level,
95 and the environment is not, things will be OK. Clearly, it is easy to tell when
96 we are sending a significant signal. Telling, if the environment is generating a
97 significant signal, and doing it with sufficient speed that the adaption will
98 not have diverged too much more we stop it, is a little harder.
99
100 The key problem in detecting when the environment is sourcing significant energy
101 is that we must do this very quickly. Given a reasonably long sample of the
102 received signal, there are a number of strategies which may be used to assess
103 whether that signal contains a strong far end component. However, by the time
104 that assessment is complete the far end signal will have already caused major
105 mis-convergence in the adaption process. An assessment algorithm is needed which
106 produces a fairly accurate result from a very short burst of far end energy.
107
108\section echo_can_page_sec_3 How do I use it?
109 The echo cancellor processes both the transmit and receive streams sample by
110 sample. The processing function is not declared inline. Unfortunately,
111 cancellation requires many operations per sample, so the call overhead is only a
112 minor burden.
113*/
114
115#include "fir.h"
116
117/* Mask bits for the adaption mode */
118 enum
119{
120 ECHO_CAN_USE_ADAPTION = 0x01,
121 ECHO_CAN_USE_NLP = 0x02,
122 ECHO_CAN_USE_CNG = 0x04,
123 ECHO_CAN_USE_CLIP = 0x08,
124 ECHO_CAN_USE_SUPPRESSOR = 0x10,
125 ECHO_CAN_USE_TX_HPF = 0x20,
126 ECHO_CAN_USE_RX_HPF = 0x40,
127 ECHO_CAN_DISABLE = 0x80
128};
129
130/*!
131 G.168 echo canceller descriptor. This defines the working state for a line
132 echo canceller.
133*/
134 typedef struct echo_can_state_s echo_can_state_t;
135
136#if defined(__cplusplus)
137 extern "C"
138{
139#endif
140
141/*! Create a voice echo canceller context.
142 \param len The length of the canceller, in samples.
143 \return The new canceller context, or NULL if the canceller could not be created.
144*/
145SPAN_DECLARE(echo_can_state_t *) echo_can_init(int len, int adaption_mode);
146
147/*! Release a voice echo canceller context.
148 \param ec The echo canceller context.
149 \return 0 for OK, else -1.
150*/
151SPAN_DECLARE(int) echo_can_release(echo_can_state_t *ec);
152
153/*! Free a voice echo canceller context.
154 \param ec The echo canceller context.
155 \return 0 for OK, else -1.
156*/
157SPAN_DECLARE(int) echo_can_free(echo_can_state_t *ec);
158
159/*! Flush (reinitialise) a voice echo canceller context.
160 \param ec The echo canceller context.
161*/
162SPAN_DECLARE(void) echo_can_flush(echo_can_state_t *ec);
163
164/*! Set the adaption mode of a voice echo canceller context.
165 \param ec The echo canceller context.
166 \param adaption_mode The mode.
167*/
168SPAN_DECLARE(void) echo_can_adaption_mode(echo_can_state_t *ec, int adaption_mode);
169
170/*! Process a sample through a voice echo canceller.
171 \param ec The echo canceller context.
172 \param tx The transmitted audio sample.
173 \param rx The received audio sample.
174 \return The clean (echo cancelled) received sample.
175*/
176SPAN_DECLARE(int16_t) echo_can_update(echo_can_state_t *ec, int16_t tx, int16_t rx);
177
178/*! Process to high pass filter the tx signal.
179 \param ec The echo canceller context.
180 \param tx The transmitted auio sample.
181 \return The HP filtered transmit sample, send this to your D/A.
182*/
183SPAN_DECLARE(int16_t) echo_can_hpf_tx(echo_can_state_t *ec, int16_t tx);
184
185SPAN_DECLARE(void) echo_can_snapshot(echo_can_state_t *ec);
186
187#if defined(__cplusplus)
188}
189#endif
190
191#endif
192/*- End of file ------------------------------------------------------------*/
echo_can_flush
void echo_can_flush(echo_can_state_t *ec)
Definition echo.c:311
echo_can_release
int echo_can_release(echo_can_state_t *ec)
Definition echo.c:286
echo_can_hpf_tx
int16_t echo_can_hpf_tx(echo_can_state_t *ec, int16_t tx)
Definition echo.c:614
echo_can_adaption_mode
void echo_can_adaption_mode(echo_can_state_t *ec, int adaption_mode)
Definition echo.c:305
echo_can_update
int16_t echo_can_update(echo_can_state_t *ec, int16_t tx, int16_t rx)
Definition echo.c:399
echo_can_free
int echo_can_free(echo_can_state_t *ec)
Definition echo.c:292
echo_can_init
echo_can_state_t * echo_can_init(int len, int adaption_mode)
Definition echo.c:241
echo_can_state_t
struct echo_can_state_s echo_can_state_t
Definition echo.h:134
echo_can_state_s
Definition private/echo.h:38